Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang.reflect
Interface AnnotatedElement

All Known Implementing Classes:
  AccessibleObject, Class, Constructor, Field, Method, Package

    public interface AnnotatedElement

Represents an annotated element of the program currently running in this VM. This interface allows annotations to be read reflectively. All annotations returned by methods in this interface are immutable and serializable. It is permissible for the caller to modify the arrays returned by accessors for array-valued enum members; it will have no affect on the arrays returned to other callers.

If an annotation returned by a method in this interface contains (directly or indirectly) a `Class`-valued member referring to a class that is not accessible in this VM, attempting to read the class by calling the relevant Class-returning method on the returned annotation will result in a `TypeNotPresentException`.

Similarly, attempting to read an enum-valued member will result in a `EnumConstantNotPresentException` if the enum constant in the annotation is no longer present in the enum type.

Finally, Attempting to read a member whose definition has evolved incompatibly will result in a `AnnotationTypeMismatchException` or an `IncompleteAnnotationException`.

Since:
  1.5

Method Summary
`
`<T extends Annotation> T`
` | `getAnnotation(Class<T> annotationClass)` Returns this element's annotation for the specified type if such an annotation is present, else null.
`Annotation[]` | `getAnnotations()` Returns all annotations present on this element.
`Annotation[]` | `getDeclaredAnnotations()` Returns all annotations that are directly present on this element.
`boolean` | `isAnnotationPresent(Class<? extends Annotation> annotationClass)` Returns true if an annotation for the specified type is present on this element, else false.

Method Detail

### isAnnotationPresent

    boolean isAnnotationPresent(Class<? extends Annotation> annotationClass)

  Returns true if an annotation for the specified type is present on this element, else false. This method is designed primarily for convenient access to marker annotations.

  Parameters:
    `annotationClass` - the Class object corresponding to the annotation type
  Returns:
    true if an annotation for the specified annotation type is present on this element, else false
  Throws:
    `NullPointerException` - if the given annotation class is null
  Since:
    1.5

### getAnnotation

    <T extends Annotation> T getAnnotation(Class<T> annotationClass)

  Returns this element's annotation for the specified type if such an annotation is present, else null.

  Parameters:
    `annotationClass` - the Class object corresponding to the annotation type
  Returns:
    this element's annotation for the specified annotation type if present on this element, else null
  Throws:
    `NullPointerException` - if the given annotation class is null
  Since:
    1.5

### getAnnotations

    Annotation[] getAnnotations()

  Returns all annotations present on this element. (Returns an array of length zero if this element has no annotations.) The caller of this method is free to modify the returned array; it will have no effect on the arrays returned to other callers.

  Returns:
    all annotations present on this element
  Since:
    1.5

### getDeclaredAnnotations

    Annotation[] getDeclaredAnnotations()

  Returns all annotations that are directly present on this element. Unlike the other methods in this interface, this method ignores inherited annotations. (Returns an array of length zero if no annotations are directly present on this element.) The caller of this method is free to modify the returned array; it will have no effect on the arrays returned to other callers.

  Returns:
    All annotations directly present on this element
  Since:
    1.5

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2009 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.